diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -2748,33 +2608,53 @@
 
 let set_present t = set_present t.t_s
 let set_absent t = set_absent t.t_s
-let present_chunks t = present_chunks t.t_s
+let present_intervals t = present_intervals t.t_s
 let print_t str t = print_s str t.t_s
 let print_uploaders t = print_uploaders t.t_s
 
 (*************************************************************************)
 (*                                                                       *)
-(*                         value_to_swarmer                              *)
+(*                         value_to_frontend                             *)
 (*                                                                       *)
 (*************************************************************************)
 
-let value_to_swarmer t assocs =
-  let get_value name conv = conv (List.assoc name assocs) in
+let value_to_frontend t assocs =
+
+  let debug_wrong_downloaded t present d =
+    lprintf_nl "ERROR: stored downloaded value not restored  !!! (%Ld/%Ld)" (downloaded t) d;
+    lprintf_nl "ERROR: present:";
+    List.iter (fun (x,y) ->
+      lprintf_nl "     (%Ld,%Ld);" x y
+    ) present;
+    
+    let p = present_intervals t in
+    lprintf_nl "ERROR: present now:";
+    
+    let total = 
+      List.fold_left (fun acc (x,y) ->
+	lprintf_nl "     (%Ld,%Ld);" x y;
+	acc ++ (y -- x)
+      ) zero p in
+    
+    lprintf_nl "ERROR: total %Ld" total;
+    if p = present then begin
+      lprintf_nl "ERROR: both appear to be the same!";
+    end;
+    if !exit_on_error then exit 2 in
 
+  let get_value name conv = conv (List.assoc name assocs) in
 
   let primary =
-    try get_value "file_primary" value_to_bool with _ -> true
-  in
+    try get_value "file_primary" value_to_bool with _ -> true in
 
   (try
-      let file_name = get_value "file_swarmer" value_to_string in
-      let s =
-        HS.find swarmers_by_name { dummy_swarmer with s_filename = file_name }
-      in
-      associate primary t s;
-(* TODO: make as many checks as possible to ensure the file and the swarmers
-  are correctly associed. *)
-    with Not_found -> ());
+    let file_name = get_value "file_swarmer" value_to_string in
+    let s = HS.find swarmers_by_name 
+	{ dummy_swarmer with s_filename = file_name } in
+    associate primary t s
+    (* TODO: make as many checks as possible to ensure the file and the swarmers
+       are correctly associed. *)
+  with Not_found -> ());
 
   let _ =
     let mtime = try file_mtime t.t_file with _ -> 0. in
@@ -2785,19 +2665,20 @@
     in
     old_mtime = mtime
   in
-(* TODO: if set_bitmap is false, we should the bitmap to 2222222222 so that
-it is verified as soon as possible. *)
+  
   (try
-      try
-        set_verified_bitmap primary t
-          (get_value  "file_chunks" value_to_string)
-      with Not_found ->
-          set_verified_bitmap primary t
-            (get_value  "file_all_chunks" value_to_string)
-
-    with e ->
-        lprintf_nl "Exception %s while loading bitmap"
-          (Printexc2.to_string e);
+    try
+      set_chunks_verified_bitmap t
+        (get_value  "file_chunks" value_to_string)
+    with Not_found ->
+      set_chunks_verified_bitmap t
+        (get_value  "file_all_chunks" value_to_string)
+	
+  with e ->
+    lprintf_nl "Exception %s while loading bitmap"
+      (Printexc2.to_string e);
+    (* force everything to be checked ASAP ? *)
+    set_chunks_verified_bitmap t (String.make (partition_size t) '2')
   );
 
   (*
@@ -2806,61 +2687,28 @@
 *)
 
   if primary then begin
-      if !verbose_swarming then lprintf_nl "Loading present...";
-      let present = try
-          let present =
-            (get_value "file_present_chunks"
-                (value_to_list value_to_int64_pair))
-          in
-          set_present t present;
-          present
-        with e ->
-            lprintf_nl "Exception %s while set present"
-              (Printexc2.to_string e);
-            []
+    if !verbose_swarming then lprintf_nl "Loading present...";
+    let present = try
+      let present =
+        (get_value "file_present_chunks"
+          (value_to_list value_to_int64_pair))
       in
-      if !verbose_swarming then lprintf_nl "Downloaded after present %Ld" (downloaded t);
-
-(*
-      if !verbose then lprintf_nl "Loading absent...";
-      (try
-          set_absent t
-            (get_value "file_absent_chunks"
-              (value_to_list value_to_int64_pair));
-        with e ->
-            if !verbose_hidden_errors then lprintf_nl "Exception %s while set absent"
-              (Printexc2.to_string e);
-      );
-      if !verbose then lprintf_nl "Downloaded after absent %Ld" (downloaded t);
-*)
-      (try
-          let d = get_value "file_downloaded" value_to_int64 in
-
-          if d <> downloaded t && !verbose then begin
-              lprintf_nl "ERROR: stored downloaded value not restored  !!! (%Ld/%Ld)" (downloaded t) d;
-              lprintf_nl "ERROR: present:";
-              List.iter (fun (x,y) ->
-                  lprintf_nl "     (%Ld,%Ld);" x y
-              ) present;
-
-              let p = present_chunks t in
-              lprintf_nl "ERROR: present now:";
-
-              let total = ref zero in
-              List.iter (fun (x,y) ->
-                  lprintf_nl "     (%Ld,%Ld);" x y;
-                  total := !total ++ (y -- x);
-              ) p;
-
-              lprintf_nl "ERROR: total %Ld" !total;
-              if p = present then begin
-                  lprintf_nl "ERROR: both appear to be the same!";
-                end;
-        if !exit_on_error then exit 2
-            end
+      set_present t present;
+      present
+    with e ->
+      lprintf_nl "Exception %s while set present"
+        (Printexc2.to_string e);
+      verify_all_chunks t;
+      []
+    in
+    if !verbose_swarming then lprintf_nl "Downloaded after present %Ld" (downloaded t);
 
-        with e -> ());
-    end;
+    (try
+      let d = get_value "file_downloaded" value_to_int64 in
+      if d <> downloaded t && !verbose then
+	debug_wrong_downloaded t present d
+    with Not_found -> ());
+  end;
 
 (* TODO re-implement this
   (try
@@ -2874,97 +2722,79 @@
 
 (*************************************************************************)
 (*                                                                       *)
-(*                         set_verified_bitmap                           *)
-(*                                                                       *)
-(*************************************************************************)
-
-let set_verified_bitmap t bitmap =
-  set_verified_bitmap (primary t) t bitmap
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         swarmer_to_value                              *)
+(*                         frontend_to_value                             *)
 (*                                                                       *)
 (*************************************************************************)
 
-let swarmer_to_value t other_vals =
-  ("file_primary", bool_to_value (primary t)) ::
-  ("file_swarmer", string_to_value t.t_s.s_filename) ::
-  ("file_mtime", float_to_value (try file_mtime t.t_file with _ -> 0.)) ::
-  ("file_chunks", string_to_value (verified_bitmap t)) ::
-  ("file_present_chunks", List
+let frontend_to_value t other_vals =
+  [("file_primary", bool_to_value t.t_primary);
+   ("file_swarmer", string_to_value t.t_s.s_filename);
+   ("file_mtime", float_to_value (try file_mtime t.t_file with _ -> 0.));
+   ("file_chunks", string_to_value (chunks_verified_bitmap t))] @
+  (if t.t_primary then
+    [("file_present_chunks", List
       (List.map (fun (i1,i2) ->
-          SmallList [int64_to_value i1; int64_to_value i2])
-      (present_chunks t))) ::
-  ("file_downloaded", int64_to_value (downloaded t)) ::
-
-  ("file_chunks_age", List (Array.to_list
-        (Array.map int_to_value t.t_last_seen))) ::
-
+        SmallList [int64_to_value i1; int64_to_value i2])
+	(present_intervals t)))] 
+   else []) @
+  [("file_downloaded", int64_to_value (downloaded t));
+   ("file_chunks_age", List (Array.to_list
+      (Array.map int_to_value t.t_last_seen)))] @
   other_vals
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         verify_one_chunk                              *)
-(*                                                                       *)
-(*************************************************************************)
+(** Verify one chunk of swarmer [s], if any frontend of that swarmer
+    has a chunk to verify *)
 
 let verify_one_chunk s =
-(*  lprintf "verify_one_chunk: %d networks\n" (List.length s.s_networks);  *)
-  List.iter (fun t ->
+  (*  lprintf "verify_one_chunk: %d networks\n" (List.length s.s_networks);  *)
+  List.exists (fun t ->
 (*      lprintf "verify_one_chunk of file %d\n" (file_num t.t_file); *)
-      let bitmap = t.t_converted_verified_bitmap in
-      for i = 0 to String.length bitmap - 1 do
-        if bitmap.[i] = '2' then begin
-(*            lprintf "  verifying...\n"; *)
-            verify_chunk t i;
-            raise Exit
-          end
-      done
-  ) s.s_networks;
+    string_existsi (fun i c ->
+      if c = '2' then verify_chunk t i;
+      c = '2') t.t_converted_verified_bitmap
+  ) s.s_networks
 (*  lprintf "verify_one_chunk: nothing done\n"; *)
-  ()
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         verify_some_chunks                            *)
-(*                                                                       *)
-(*************************************************************************)
+(** Verify one chunk of each swarmer that needs it *)
 
 let verify_some_chunks () =
   HS.iter (fun s ->
-      try
-        verify_one_chunk s
-      with _ -> ()) swarmers_by_name
+    try
+      ignore(verify_one_chunk s)
+    with _ -> ()
+  ) swarmers_by_name
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         verify_one_chunk                              *)
-(*                                                                       *)
-(*************************************************************************)
+(** Verify one chunk of the swarmer associated with [t], if needed *)
 
 let verify_one_chunk t =
-  verify_one_chunk t.t_s
+  ignore(verify_one_chunk t.t_s)
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         merge                                         *)
-(*                                                                       *)
-(*************************************************************************)
+(** Merge a second frontend [f2] to a first one [f1], so they share
+    the same swarmer.
+
+    First swarmer [f1] must support some hashing scheme.
+    Data of the second swarmer [f2] is currently lost during merging, so
+    you'd better merge in swarmers quickly.
+    Merging is denied if any of the two frontends is being used, so it
+    may be necessary to pause them first, to get rid of any downloads.
+*)
 
 let merge f1 f2 =
 
-  let s1 = HS.find swarmers_by_name { dummy_swarmer with s_filename = file_disk_name f1 } in
-  let s2 = HS.find swarmers_by_name { dummy_swarmer with s_filename = file_disk_name f2 } in
+  let s1 = HS.find swarmers_by_name { dummy_swarmer with 
+    s_filename = file_disk_name f1 } in
+  let s2 = HS.find swarmers_by_name { dummy_swarmer with 
+    s_filename = file_disk_name f2 } in
 
-  if s1 == s2 then
+  if s1.s_filename = s2.s_filename then
     failwith "Files are already sharing their swarmer";
 
   if s1.s_size <> s2.s_size then
     failwith "Files don't have the same size";
 
-  let t2 = match s2.s_networks with
-      [t] -> t
+  let t2 = 
+    match s2.s_networks with
+    | [t] -> t
     | list ->
         lprintf_nl "s_networks: %d files" (List.length list);
         failwith "Second file is already merged with other files"
@@ -2972,24 +2802,22 @@
 
   let t1 =
     match s1.s_networks with
-      [] -> assert false
+    | [] -> assert false
     | t1 :: _ ->
         match t1.t_verifier with
-          NoVerification ->
+	| NoVerification | VerificationNotAvailable ->
             failwith "Cannot use first file as a primary for swarming (no verification scheme)"
-        | _ -> t1
+        | Verification _ | ForceVerification -> t1
   in
 
-  begin
-    List.iter (fun (s, filename) ->
-        for i = 0 to Array.length s.s_nuploading -  1 do
-          if s.s_nuploading.(i) > 0 then
-            failwith (Printf.sprintf "%s is currently being downloaded" filename)
-        done
-    ) [
-      s1, "First file";
-      s2, "Second file" ];
-  end;
+  List.iter (fun (s, filename) ->
+    Array.iteri (fun i nuploading ->
+      if nuploading > 0 then
+        failwith (Printf.sprintf "%s is currently being downloaded" filename)
+    ) s.s_nuploading
+  ) [
+    s1, "First file";
+    s2, "Second file"];
 
 (* replace T2 swarmer *)
   associate false t2 t1.t_s
@@ -3001,7 +2829,7 @@
 (*************************************************************************)
 
 let has_secondaries t =
-  primary t && List.length t.t_s.s_networks > 1
+  t.t_primary && List.length t.t_s.s_networks > 1
 
 (*************************************************************************)
 (*                                                                       *)
@@ -3011,7 +2839,7 @@
 
 let remove_swarmer file_swarmer =
   match file_swarmer with 
-    None -> () 
+  | None -> () 
   | Some sw -> if not (has_secondaries sw)
                 then HS.remove swarmers_by_name sw.t_s
                 else lprintf_nl "Tried to remove swarmer with secondaries"
@@ -3035,11 +2863,11 @@
 
     let value_to_swarmer v =
       match v with
-        Module assocs ->
+      | Module assocs ->
           let get_value name conv = conv (List.assoc name assocs) in
           let file_size = get_value "file_size" value_to_int64 in
           let file_name = get_value "file_name" value_to_string in
-          let s = create_swarmer file_name file_size edonkey_range_size in
+          let s = create_swarmer file_name file_size in
           let block_sizes = get_value "file_chunk_sizes"
               (value_to_list value_to_int64) in
           List.iter (fun bsize ->
@@ -3055,7 +2883,7 @@
         ("file_name", string_to_value s.s_filename);
         ("file_bitmap", string_to_value s.s_verified_bitmap);
         ("file_chunk_sizes", list_to_value int64_to_value
-            (List.map (fun t -> t.t_block_size) s.s_networks));
+            (List.map (fun t -> t.t_chunk_size) s.s_networks));
         ]
 
     let t =
@@ -3063,55 +2891,49 @@
 
   end
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         check_swarmer                                 *)
-(*                                                                       *)
-(*************************************************************************)
+(** Checks most variants of a swarmer, nobably verification bitmaps
+    consistency; Raise an exception if a problem is found *)
 
 let check_swarmer s =
   try
     match s.s_networks with
-      [] -> ()
-    | t :: tail ->
-        assert  t.t_primary;
-
-        for i = 0 to t.t_nchunks - 1 do
-          List.iter (fun j ->
-              if t.t_converted_verified_bitmap.[i] = '3' then begin
-                  if s.s_verified_bitmap.[j] <> '3' then
-                    failwith "Bad propagation of 3 from primary to main";
-                end
-              else
-              if s.s_verified_bitmap.[j] = '3' then begin
-                  failwith "Main has 3 not coming from primary";
-                end
-          ) t.t_blocks_of_chunk.(i)
-        done;
+    | [] -> assert false
+    | tprim :: tail ->
+        assert(tprim.t_primary);
+
+	string_iter (fun i c ->
+	    if c = '3' then begin
+	      if List.exists (fun j -> s.s_verified_bitmap.[j] <> '3') 
+		tprim.t_blocks_of_chunk.(i) then
+                  failwith "Bad propagation of 3 from primary to swarmer";
+            end
+            else if List.exists (fun j -> s.s_verified_bitmap.[j] = '3')
+	      tprim.t_blocks_of_chunk.(i) then
+                failwith "Swarmer has 3 not coming from primary";
+	) tprim.t_converted_verified_bitmap;
 
-        let fd = file_fd t.t_file in
+        let fd = file_fd tprim.t_file in
 
         List.iter (fun t ->
-            assert (not t.t_primary);
-            assert (file_fd t.t_file == fd);
-
-            for i = 0 to t.t_nchunks - 1 do
-              List.iter (fun j ->
-                  if t.t_converted_verified_bitmap.[i] = '3' then begin
-                      if s.s_verified_bitmap.[j] <> '3' then
-                        failwith "3 in secondary without 3 in primary";
-                    end
-                  else
-                  if t.t_converted_verified_bitmap.[i] = '2' then begin
-                      if s.s_verified_bitmap.[j] <> '3' then
-                        failwith "2 in secondary without 3 in primary";
-                    end
-              ) t.t_blocks_of_chunk.(i)
-            done;
+          assert (not t.t_primary);
+          assert (file_fd t.t_file == fd);
+	  
+	  string_iter (fun i c ->
+	    if c = '3' then begin
+	      if List.exists (fun j -> s.s_verified_bitmap.[j] <> '3')
+		t.t_blocks_of_chunk.(i) then
+                  failwith "3 in secondary without 3 in primary"
+	    end 
+	    else if c = '2' then begin
+	      if List.exists (fun j -> s.s_verified_bitmap.[j] <> '3')
+		t.t_blocks_of_chunk.(i) then
+                  failwith "2 in secondary without 3 in primary"
+	    end 
+	  ) t.t_converted_verified_bitmap
         ) tail
   with e ->
-      print_s "ERROR" s;
-      raise e
+    print_s "ERROR" s;
+    raise e
 
 (*************************************************************************)
 (*                                                                       *)
@@ -3132,19 +2954,18 @@
 let _ =
   set_after_save_hook files_ini (fun _ -> swarmers =:= []);
   set_before_save_hook files_ini (fun _ ->
-      let list = ref [] in
-      HS.iter (fun s ->
-          if s.s_networks <> [] then
-          list := s :: !list) swarmers_by_name;
-      swarmers =:= !list
+    let list = ref [] in
+    HS.iter (fun s ->
+      if s.s_networks <> [] then
+        list := s :: !list) swarmers_by_name;
+    swarmers =:= !list
   );
   set_after_load_hook files_ini (fun _ ->
-      List.iter (fun s ->
-          check_swarmer s;
-      ) !!swarmers;
-
-      swarmers =:= [])
-
+    List.iter (fun s ->
+      check_swarmer s;
+    ) !!swarmers;
+    swarmers =:= []
+  )
 
 (*************************************************************************)
 (*                                                                       *)
@@ -3191,9 +3012,8 @@
             Array.length up.up_complete_blocks * 4 +
             List.length up.up_ranges * (12 + 16 + 12 + 12 +  4) +
             Array.length up.up_partial_blocks * (16 + 12 + 12) +
-            (8 + match up.up_chunks with
-              AvailableRanges list -> List.length list * (12 + 12 + 12 + 12)
-            | AvailableCharBitmap s -> 8 + String.length s
+            (8 + match up.up_intervals with
+            | AvailableIntervals list -> List.length list * (12 + 12 + 12 + 12)
             | AvailableBitv b -> let ws = Sys.word_size in (ws/8) + ((ws / 8) * (Bitv.length b / (ws - 2))) 
           ) ;
           incr counter;
@@ -3201,20 +3021,3 @@
       Printf.bprintf buf "  Uploaders: %d\n" !counter;
       Printf.bprintf buf "  Storage: %d bytes\n" !storage;
   )
-
-let check_finished t =
-  try
-    let file = t.t_file in
-    match file_state file with
-      FileCancelled | FileShared | FileDownloaded -> false
-    | _ ->
-        let bitmap = verified_bitmap t in
-        for i = 0 to String.length bitmap - 1 do
-          if bitmap.[i] <> '3' then raise Not_found;
-        done;
-        if file_size file <> downloaded t then
-          lprintf_nl "Downloaded size differs after complete verification";
-        true
-  with _ -> false
-
-
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/bittorrent/bTClients.ml ./src/networks/bittorrent/bTClients.ml
--- ./src/networks/bittorrent/bTClients.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/bittorrent/bTClients.ml	2006-05-25 20:46:10.000000000 +0200
@@ -390,7 +390,7 @@
 (* This must be a seeded file... *)
         String.make (Array.length c.client_file.file_chunks) '3'
     | Some swarmer ->
-        CommonSwarming.verified_bitmap swarmer
+        CommonSwarming.chunks_verified_bitmap swarmer
   in
 
   if !verbose_download then lprintf_nl "Sending verified bitmap: [%s]" bitmap;
@@ -550,7 +550,7 @@
     match c.client_uploader with
       None ->
         let up = CommonSwarming.register_uploader swarmer (as_client c)
-          (AvailableRanges []) in
+          (AvailableIntervals []) in
         c.client_uploader <- Some up;
         up
     | Some up ->
@@ -570,7 +570,7 @@
     let chunks = c.client_new_chunks in
     c.client_new_chunks <- [];
     List.iter (fun n -> Bitv.set bitmap n true) chunks;
-    CommonSwarming.update_uploader up (AvailableBitv bitmap);
+    CommonSwarming.update_uploader_intervals up (AvailableBitv bitmap);
   end
 
 
@@ -680,7 +680,7 @@
                         c.client_range_waiting <- None;
                         (x,y,r)
                   | None -> 
-                        CommonSwarming.find_range up 
+                        CommonSwarming.find_range up (min max_range_len file.file_piece_size)
                 in
 
                 let (x,y,r) =
@@ -695,7 +695,7 @@
                   c.client_ranges_sent <- c.client_ranges_sent @ [x,y, r];
 (*                CommonSwarming.alloc_range r; *)
                 
-                  let num = CommonSwarming.block_num swarmer b in
+                  let num = CommonSwarming.block_chunk_num swarmer b in
 
                   if !verbose_swarming then 
                     lprintf_nl "Asking %d For Range %Ld-%Ld" num x y;
@@ -906,7 +906,7 @@
                 disconnect_client c (Closed_for_error "Wrong bitfield length")
               end else begin
 
-                let verified = CommonSwarming.verified_bitmap swarmer in
+                let verified = CommonSwarming.chunks_verified_bitmap swarmer in
 
                 for i = 0 to npieces - 1 do
                   if is_bit_set p i then begin
@@ -941,7 +941,7 @@
             None -> ()
           | Some swarmer ->
               let n = Int64.to_int n in
-              let verified = CommonSwarming.verified_bitmap swarmer in
+              let verified = CommonSwarming.chunks_verified_bitmap swarmer in
               (* lprintf_nl "verified: %c;" verified.[n]; *)
               (* if the peer has a chunk we don't, tell him we're interested and update his bitmap *)
               if verified.[n] < '2' then begin
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/bittorrent/bTComplexOptions.ml ./src/networks/bittorrent/bTComplexOptions.ml
--- ./src/networks/bittorrent/bTComplexOptions.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/bittorrent/bTComplexOptions.ml	2006-05-25 20:46:10.000000000 +0200
@@ -205,7 +205,7 @@
   (match file.file_swarmer with
       None -> ()
     | Some swarmer ->
-        CommonSwarming.value_to_swarmer swarmer assocs;
+        CommonSwarming.value_to_frontend swarmer assocs;
   );
 
 (*
@@ -257,7 +257,7 @@
     match file.file_swarmer with
       None -> assocs
     | Some swarmer ->
-        CommonSwarming.swarmer_to_value swarmer assocs
+        CommonSwarming.frontend_to_value swarmer assocs
   with
     e ->
       lprintf_nl "exception %s in file_to_value"
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/bittorrent/bTGlobals.ml ./src/networks/bittorrent/bTGlobals.ml
--- ./src/networks/bittorrent/bTGlobals.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/bittorrent/bTGlobals.ml	2006-05-25 20:46:10.000000000 +0200
@@ -154,9 +154,9 @@
       (match c.client_block with
           None -> true
         | Some b ->
-            let block_num = CommonSwarming.block_num swarmer b in
-            let bitmap = CommonSwarming.verified_bitmap swarmer in
-            bitmap.[block_num] <> '3')
+            let chunk_num = CommonSwarming.block_chunk_num swarmer b in
+            let bitmap = CommonSwarming.chunks_verified_bitmap swarmer in
+            bitmap.[chunk_num] <> '3')
     in
     if must_send then
       begin
@@ -261,8 +261,7 @@
       else
         set_trackers file [t.torrent_announce];
       if file_state <> FileShared then begin
-          let kernel = CommonSwarming.create_swarmer file_temp (file_size file)
-            (min max_range_len file.file_piece_size) in
+          let kernel = CommonSwarming.create_swarmer file_temp (file_size file) in
           let swarmer = CommonSwarming.create kernel (as_file file)
             file.file_piece_size in
           file.file_swarmer <- Some swarmer;
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/bittorrent/bTInteractive.ml ./src/networks/bittorrent/bTInteractive.ml
--- ./src/networks/bittorrent/bTInteractive.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/bittorrent/bTInteractive.ml	2006-05-25 20:46:10.000000000 +0200
@@ -278,7 +278,7 @@
 
       let chunks = (match file.file_swarmer with
             None -> "" | Some swarmer ->
-              CommonSwarming.verified_bitmap swarmer) in
+              CommonSwarming.chunks_verified_bitmap swarmer) in
 
       let header_list = [
         ( "1", "srh br ac", "Client number", "Num" ) ;
@@ -371,7 +371,7 @@
     None ->
       lprintf_nl "verify_chunks: no swarmer to verify chunks"
   | Some swarmer ->
-      CommonSwarming.verify_all_chunks swarmer true
+      CommonSwarming.verify_all_chunks_immediately swarmer
 
 let remove_all_clients file =
   Hashtbl.clear file.file_clients; 
@@ -407,11 +407,11 @@
     P.file_names = [file.file_name, P.noips()];
     P.file_chunks = (match file.file_swarmer with
         None -> "" | Some swarmer ->
-          CommonSwarming.verified_bitmap swarmer);
+          CommonSwarming.chunks_verified_bitmap swarmer);
     P.file_availability =
     [network.network_num,(match file.file_swarmer with
           None -> "" | Some swarmer ->
-            CommonSwarming.availability swarmer)];
+            CommonSwarming.chunks_availability swarmer)];
 
     P.file_chunks_age = last_seen;
     P.file_uids = [Uid.create (BTUrl file.file_id)];
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyClient.ml ./src/networks/donkey/donkeyClient.ml
--- ./src/networks/donkey/donkeyClient.ml	2006-05-20 22:10:50.000000000 +0200
+++ ./src/networks/donkey/donkeyClient.ml	2006-05-25 20:46:10.000000000 +0200
@@ -856,7 +856,7 @@
   match file.file_swarmer with
     None -> false
   | Some swarmer ->
-      let bitmap = CommonSwarming.verified_bitmap swarmer in
+      let bitmap = CommonSwarming.chunks_verified_bitmap swarmer in
       let rec iter bitmap chunks i len =
         if i = len then false else
         if Bitv.get chunks i && bitmap.[i] < '2' then true else
@@ -873,7 +873,7 @@
       match file.file_swarmer with
         None -> ()
       | Some swarmer ->
-          lprintf_nl "   %s" (CommonSwarming.verified_bitmap swarmer);
+          lprintf_nl "   %s" (CommonSwarming.chunks_verified_bitmap swarmer);
     end;
   
   let chunks = 
@@ -1940,7 +1940,7 @@
                        asume that we have all chunks! *)
                     Bitv.create file.file_nchunks true
               | Some swarmer ->
-                  let bitmap = CommonSwarming.verified_bitmap swarmer in
+                  let bitmap = CommonSwarming.chunks_verified_bitmap swarmer in
                   Bitv.init (String.length bitmap) 
                       (fun i -> bitmap.[i] = '3')
                   (* This is not very smart, as we might get banned for this request.
@@ -2532,7 +2532,7 @@
             match file.file_swarmer with
               None -> None
             | Some swarmer ->
-                let bitmap = CommonSwarming.verified_bitmap swarmer in
+                let bitmap = CommonSwarming.chunks_verified_bitmap swarmer in
                 let chunks = 
                   Bitv.init (String.length bitmap) 
                   (fun i -> bitmap.[i] = '3')
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyComplexOptions.ml ./src/networks/donkey/donkeyComplexOptions.ml
--- ./src/networks/donkey/donkeyComplexOptions.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/donkey/donkeyComplexOptions.ml	2006-05-25 20:46:10.000000000 +0200
@@ -293,7 +293,7 @@
   (match file.file_swarmer with
       None -> ()
     | Some swarmer ->
-        CommonSwarming.value_to_swarmer swarmer assocs;
+        CommonSwarming.value_to_frontend swarmer assocs;
         CommonSwarming.set_verifier swarmer (if md4s = [||] then
             VerificationNotAvailable
           else
@@ -317,7 +317,7 @@
   match file.file_swarmer with
     None -> fields
     | Some swarmer ->
-        CommonSwarming.swarmer_to_value swarmer fields
+        CommonSwarming.frontend_to_value swarmer fields
   in
   fields
     
diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/networks/donkey/donkeyGlobals.ml ./src/networks/donkey/donkeyGlobals.ml
--- ./src/networks/donkey/donkeyGlobals.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/networks/donkey/donkeyGlobals.ml	2006-05-25 20:46:10.000000000 +0200
@@ -390,7 +390,7 @@
       (match file_state with
           FileShared -> ()
         | _ ->
-            let kernel = CommonSwarming.create_swarmer file_diskname file_size zone_size in
+            let kernel = CommonSwarming.create_swarmer file_diskname file_size in
             let swarmer = CommonSwarming.create kernel (as_file file) block_size
             in
             file.file_swarmer <- Some swarmer;
